﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim tmrGame As Timer
	Dim tmrCountdown As Timer
	Dim bc As ByteConverter
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim GGS As gGoogleGameService
	Dim btnClick As Button
	Dim btnInviteFriends As Button
	Dim btnPlayRandom As Button
	Dim btnPlaySolo As Button
	Dim btnSeeInvites As Button
	Dim lblScore As Label
	Dim lblTime As Label
	Dim pnlGame As Panel
	Dim pnlPlayerScores As Panel
	Dim pnlSelect As Panel
	Dim Room As gRoom
	Dim roomConfig As gRoomConfig
	Dim myID As String
	
	Dim bGameLeader As Boolean 'to track who created the room, for handling the timer portion
	Dim bPlaySolo As Boolean 'for use if group play or not
	Dim myScore As Int
	Dim listParticipants As List
	Dim remainingTime As Double
	Dim remainingCountdown As Int
	Dim lastTimeTick As Long 'to track how much time has actually passed since last tick
	Dim bGameStarted As Boolean 'for tracking when to log points, and when to finish
	Dim mMsgBuf(2) As Byte
	
	Dim APShrink As AnimationPlus
	Dim btnShrink As Button
	
	Dim myCountdownToken As Int
	Dim myCountdownTime As Int = 9999
	Dim myStopToken As Int = 9999
	
	Dim inviteTime As Long 'for use when playing Random Game to determine leader
	Dim bRandomGame As Boolean
	
	
	Dim mapParticipants As Map 'for tracking score from each participant
	Type participantData (score As Int, nameView As Label, scoreView As Label, imgView As ImageView)
	Dim lblNameP1 As Label
	Dim lblNameP2 As Label
	Dim lblNameP3 As Label
	Dim lblScoreP1 As Label
	Dim lblScoreP2 As Label
	Dim lblScoreP3 As Label
	Dim btnLeaveRoom As Button
	Dim imgPlayer As ImageView
	Dim imgP1 As ImageView
	Dim imgP2 As ImageView
	Dim imgP3 As ImageView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("ButtonClick.bal")
	APShrink = Null
	GGS.initialize("GGS")
	GGS.onStart(True)	
	pnlSelect.Left = 0
	pnlSelect.Top = 0
	Room.initialize("Room")
	tmrCountdown.Initialize("tmrCountdown", DateTime.TicksPerSecond * 1)
	tmrGame.Initialize("tmrGame", DateTime.TicksPerSecond * .1)
End Sub

Sub Activity_Resume
	GGS.onStart(True)
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	GGS.onStop(UserClosed)
	tmrGame.Enabled = False
	tmrCountdown.Enabled = False
End Sub

'I have not had a successful check using .getInvitationId(gGameService) but everything seems to be good in the Java code
'However, the .loadInvitations does work
Sub GGS_OnSignInSucceeded
	roomConfig.initialize("RoomConfig", GGS.GamesClient)
	roomConfig.loadInvitations(GGS.GamesClient) 'remember, this requires the listener, below
	If Not(roomConfig.getInvitationId(GGS) = Null) Then
		Msgbox("You have invites", "You so popular!")
	End If

	GGS.GamesClient.CurrentPlayer.loadIconImage(imgPlayer) 'start the loadup process of players icon

End Sub


'I have not had a successful check on this... but everything seems to be good in the Java code
'I have only had one succesful check with the Google official app, so not sure where the problem lies
Sub EventName_OnInvitationRecieved (invite As gInvitation)
	Msgbox("Check your invites!", "A game calls")
	
End Sub

'This method does work to see if invitations exist
Sub roomconfig_OnInvitationsLoaded (listGInvitations As List)
	If listGInvitations = Null Then Return
	
	Msgbox("check your invitations", "You devil you")
	For Each iw As gInvitation In listGInvitations
		Log(iw.InvitationId & " is the id")
	Next
	
End Sub


Sub btnSeeInvites_Click
	'roomConfig.initialize("roomConfig")
	bPlaySolo = False
	bRandomGame = False
	roomConfig.seeInvitations(GGS.GamesClient)
End Sub
Sub btnPlaySolo_Click
	bPlaySolo = True
	bRandomGame = False
	SetupPlay
End Sub
Sub btnPlayRandom_Click
	bPlaySolo = False
	bRandomGame = True
	inviteTime = DateTime.Now
	roomConfig.initialize("roomConfig", GGS.GamesClient)
	roomConfig.setMatchCriteria(1, 1, 0)
	roomConfig.createRoom(GGS.GamesClient)
End Sub


Sub btnInviteFriends_Click
	bPlaySolo = False
	bRandomGame = False
	'roomConfig.initialize("roomConfig", GGS.GamesClient)
	If GGS.GamesClient.isConnected Then
		roomConfig.invitePlayers(GGS.GamesClient)
	End If
End Sub


'if listIds is null, then something with process wrong or cancelled
Sub roomConfig_OnInvitePlayersComplete(listPlayerIds As Object)
	Log("got back the listener")
	If listPlayerIds = Null Then Return
	'roomConfig.initialize("RoomConfig", GGS.GamesClient)
	roomConfig.addPlayersToInvite(listPlayerIds)
	roomConfig.createRoom(GGS.GamesClient)
End Sub
Sub btnClick_Click
	If Not(bGameStarted) Then Return
	myScore = myScore + 1
	lblScore.Text = myScore
	If Not(bPlaySolo) Then
		broadcastMyScore
	End If
End Sub


Sub GGS_onSignInFailed
	Msgbox("Sign in error", "Error")
End Sub

'statusCode seems to vary, so only check if good to go
Sub roomConfig_OnRoomCreated(statusCode As Int, aRoom As Object)
Log("Room is created")
'Msgbox("room is created", "ok")
Log(roomConfig.RESULT_OK)
	If Not(statusCode = GGS.GamesClient.STATUS_OK ) Then
		If statusCode = 6 Then 
			ResetClient
			Msgbox("Network error, resetting.  Try inviting again.", "Network Error")
		Else
			ResetClient
			Msgbox("Something wrong during room creation.  Does your friend have game installed?", "Error")
		End If
		Log("statusCode returned for invite bad is: " & statusCode)
		Return
	End If

	Room.Room = aRoom
	listParticipants = Room.Participants
	Log(listParticipants.Size & ":size with " & listParticipants)
	myID = Room.getParticipantId(GGS.GamesClient.CurrentPlayerId)
	setupParticipantMap
	If Not(bRandomGame) Then
		bGameLeader = True
	End If
	roomConfig.showWaitingRoom(Room, GGS.GamesClient, 2)
		
End Sub

Sub roomconfig_OnWaitingRoomResponse(resultCode As Int, Intent As Object)
	If resultCode = roomConfig.RESULT_CANCELED Then
		Log("waiting cancelled")
		For Each p As gParticipant In Room.Participants
			If Not(p.ParticipantId = myID) Then
				If Room.getParticipantStatus(p.ParticipantId) = p.STATUS_JOINED Then
					SetupPlay
				End If
			End If
		Next
	Else If resultCode = roomConfig.RESULT_LEFT_ROOM Then
		Log("left waiting room")
		For Each p As gParticipant In Room.Participants
			If Not(p.ParticipantId = myID) Then
				Log (Room.getParticipantStatus(p.ParticipantId))
				Log(p.STATUS_JOINED)
				If Room.getParticipantStatus(p.ParticipantId) = p.STATUS_JOINED Then
					SetupPlay
				End If
			End If
		Next
	Else If resultCode = roomConfig.RESULT_OK Then
		Log("in waiting room response")
		If bRandomGame Then
			Log(Room.ParticipantIds & " and size: "& Room.ParticipantIds.Size)
			DetermineALeader
		Else
			SetupPlay
		End If
	Else
		Msgbox("how'd we get here", "huh?")
	End If
End Sub



Sub roomConfig_OnInvitationsComplete (resultCode As Int, invitation As gInvitation)
	If invitation = Null Then Return
	AcceptInvite(invitation.InvitationId)
End Sub

Sub AcceptInvite(inviteID As String)
	'roomConfig.initialize("RoomConfig", GGS.GamesClient)
	roomConfig.joinRoom(inviteID, GGS.GamesClient)
End Sub

Sub roomConfig_OnConnectedToRoom(aRoom As gRoom)
	Room = aRoom
	listParticipants = aRoom.Participants
	Log("in the room on connected and size is: " & listParticipants.Size)
	myID = aRoom.getParticipantId(GGS.GamesClient.CurrentPlayerId)
	setupParticipantMap
	SetupPlay
End Sub

'will determine who is the leader.. unless two or more players just happen to hit go at same time
Sub DetermineALeader
	Log("sending leader message:" & inviteTime)
	Dim newMsgBuf() As Byte
	newMsgBuf = NewMessageMaker("F", inviteTime)
	For Each par As gParticipant In listParticipants
		If Not(par.ParticipantId=myID) Then
			Log("sent to " & par.ParticipantId)
			roomConfig.sendReliableRealTimeMessage(Room, GGS.GamesClient, par.ParticipantId, newMsgBuf)
		End If
	Next
End Sub

'msg back.. am I the leader?  if so, start the countdown
Sub LeaderDetermined(opponentTime As Long)
	Log("leader is determined")
	If opponentTime < inviteTime Then
		Log("and it is me")
		bGameLeader = True
	End If
	SetupPlay
End Sub

'We treat most of the Room update callbacks In the same way: we update our List of
'participants AND update the display. In a real game we would also have To check If that
'change requires some action like removing the corresponding player avatar from the screen,
'etc. 

Sub roomConfig_onPeerDeclined (aRoom As gRoom, listParticipantIDs As Object)
	Log("OPD")
	updateRoom(aRoom)
End Sub

Sub roomConfig_OnRoomConnected (statusCode As Int, aRoom As gRoom)
	Log("ORC")
	updateRoom(aRoom)
End Sub


Sub roomConfig_OnJoinedRoom (statusCode As Int, aRoom As gRoom)
	Log ("OJR")
	updateRoom(aRoom)
End Sub

Sub roomConfig_onPeerInvitedToRoom (aRoom As gRoom, listParticipantIDs As Object)
	Log("OPITR")
	updateRoom(aRoom)
End Sub

Sub roomConfig_onPeerJoined (aRoom As gRoom, listParticipantIDs As Object)
	Log("OPJ")
	updateRoom(aRoom)
End Sub

Sub roomConfig_onPeerLeft (aRoom As gRoom, listParticipantIDs As Object)
	Log("OPL")
	updateRoom(aRoom)
End Sub

Sub roomConfig_onRoomAutoMatching (aRoom As gRoom)
	Log("ORAM")
	updateRoom(aRoom)
End Sub

Sub roomConfig_onRoomConnecting (aRoom As gRoom)
	Log("ORConnecting")
	updateRoom(aRoom)
End Sub

Sub roomConfig_onPeersConnected (aRoom As gRoom, listParticipantIDs As Object)
	Log("OPC")
	Log(aRoom.Participants.Size & " is size in OPC")
	updateRoom(aRoom)
End Sub

Sub roomConfig_onPeersDisconnected (aRoom As gRoom, listParticipantIDs As Object)
	Log("OPD2")
	updateRoom(aRoom)
End Sub

Sub updateRoom(aRoom As gRoom)
	Log("got some update hits")
	listParticipants = aRoom.Participants
	updatePeerScoresDisplay
End Sub

Sub updatePeerScoresDisplay

End Sub

Sub SetupPlay
pnlSelect.Left = 100%x
pnlGame.Left = 0
pnlGame.Top = 0
myScore = 0
remainingTime = 20
lblTime.Text = remainingTime
lblScore.Text = myScore
bGameStarted = False
If bPlaySolo OR bGameLeader Then 
	startCountdown
End If
End Sub


'used to display a 3, 2, 1 effect for starting
Sub startCountdown
	remainingCountdown = 3
	tmrCountdown.Enabled = True
End Sub

Sub tmrCountdown_Tick
	If remainingCountdown = 0 Then
		tmrCountdown.Enabled = False
	End If
	
	Dim newMsgBuf() As Byte
	newMsgBuf = NewMessageMaker("CD", remainingCountdown)
	'Log(newMsgBuf.Length  & " is the sending length")
	
	If bPlaySolo Then
		showCountdown(remainingCountdown)
		remainingCountdown = remainingCountdown - 1
		Return
	End If
	'Log("checking the participant in tmrCountdown")
	For Each par As gParticipant In listParticipants
		If par.ParticipantId = myID Then
			'changed to see how syncing works
		'	Log("equal to my id")
		Else
		'	Log("should be sending message")
			myCountdownToken = roomConfig.sendReliableRealTimeMessage(Room, GGS.GamesClient, par.ParticipantId, newMsgBuf)
			myCountdownTime = remainingCountdown
		End If
	Next
	remainingCountdown = remainingCountdown - 1
	
End Sub

Sub tmrGame_Tick
	If remainingTime < .1 Then
		broadcasttime(0, True)
		tmrGame.Enabled = False
		If Not(bPlaySolo) Then
			broadcastEndGame
		End If
	Else
		broadcasttime(remainingTime, False)
	End If
	remainingTime = NumberFormat(remainingTime - .1, 0, 1)
End Sub
	

Sub roomConfig_OnRealTimeMessageRecieved (isReliable As Boolean, buffer() As Byte, participantID As String)
	'Log("in received")
	
	HandleMessage(buffer, isReliable, participantID)
	

	
End Sub

Sub roomConfig_OnRealTimeMessageSent (statusCode As Int, tokenID As Int, participantID As String)
	'Log("in sent")
	If tokenID = myCountdownToken  Then
		showCountdown(myCountdownTime)
	Else If tokenID = myStopToken Then
		'this is the message that the final time has been sent and received.. kill my game
		bGameStarted = False
		ShowEndGame("ortms")
	End If
	
End Sub

Sub showCountdown(remainingCountdownTime As Int)
	If APShrink = Null Then
	Else If APShrink.IsInitialized Then
		Return
	End If
'	For i = 0 To bc.SupportedEncodings.Length - 1
'		Log(bc.SupportedEncodings(i))
'	Next
	btnShrink.Initialize("btnShrink")
	If remainingCountdownTime = 0 Then
		btnShrink.Text = "GO!"
		btnShrink.Color = Colors.Transparent
		Activity.AddView(btnShrink, 10%x, 30%y, 80%x, 40%y)
		btnShrink.TextSize = btnShrink.Height * 700/1000dip
		APShrink.InitializeAlpha("AnimPlus", 1, 0)
		APShrink.Duration = 700
		bGameStarted = True
		If bGameLeader OR bPlaySolo Then
			tmrGame.Enabled = True
			lastTimeTick = DateTime.Now
		End If
	Else
		btnShrink.Text = remainingCountdownTime
		btnShrink.Color = Colors.Transparent
		Activity.AddView(btnShrink, 30%x, 30%y, 40%x, 40%y)
		btnShrink.TextSize = btnShrink.Height * 700/1000dip
		APShrink.InitializeScaleCenter("AnimPlus", 1, 1, 0, 0, btnShrink)
		APShrink.Duration = 700
	End If
	APShrink.Start(btnShrink)
End Sub

Sub AnimPlus_AnimationEnd
	btnShrink.RemoveView
	APShrink = Null
End Sub

'takes in two components and turns them into a byte array for sending
'via google, valid identifiers are:
'"CD" for countdown
'"S" for score
'"T" for time remaining
Sub NewMessageMaker(identifier As String, message As String) As Byte()
	If identifier <> "CD" AND identifier <> "S" AND identifier <> "T" AND identifier <> "F" AND identifier <> "EG" Then
		Msgbox("building an unknown message", "Unknown message type")
	End If
	Dim newByte() As Byte
	newByte = bc.StringToBytes(identifier & message, "UTF-8")
	'Log(newByte.Length & " is length")
	Return newByte
End Sub

Sub HandleMessage(message() As Byte, isReliable As Boolean, participantID As String)
	'Log("in handle message")
	'Log(message.Length  & " is length")
	Dim newMessage As String
	newMessage = bc.StringFromBytes(message, "UTF-8")
	
	'Log(newMessage)
	
	If newMessage.StartsWith("CD") Then
		'this is a countdown message
		showCountdown(newMessage.SubString(2))
	Else If newMessage.StartsWith("T") Then
		'to handle time updates
		updateTime(newMessage.SubString("1"))
	Else If newMessage.StartsWith("S") Then
		'to handle scores
		updateOpponentScore(participantID, newMessage.SubString(1))
	Else If newMessage.StartsWith("F") Then
		LeaderDetermined(newMessage.SubString(1))
	Else If newMessage.StartsWith("EG") Then
		bGameStarted = False
		ShowEndGame("hm")
	End If
End Sub

'if the message is unreliable, just send and call the update clock function
'if reliable, be sure to set the myStopToken so when that is received, gameLeader
'will stop his game too
Sub broadcasttime(timeLeft As Float, sendReliable As Boolean)
	If bPlaySolo Then
		updateTime(timeLeft)
		Return
	End If
	If Not(sendReliable) Then
		Dim newMsgBuf() As Byte
		newMsgBuf = NewMessageMaker("T", timeLeft)
		For Each par As gParticipant In listParticipants
			If Not(par.ParticipantId = myID) Then
				roomConfig.sendUnreliableRealTimeMessage(Room, GGS.GamesClient, par.ParticipantId, newMsgBuf)
			Else
				updateTime(timeLeft)
			End If
		Next
	Else
		Dim newMsgBuf() As Byte
		newMsgBuf = NewMessageMaker("T", timeLeft)
		For Each par As gParticipant In listParticipants
			If Not(par.ParticipantId=myID) Then
				myStopToken = roomConfig.sendReliableRealTimeMessage(Room, GGS.GamesClient, par.ParticipantId, newMsgBuf)
			Else
				updateTime(timeLeft)
			End If
		Next
	End If
End Sub

'this sub ensures that each other player's game ends and the leaveroom button is displayed
Sub broadcastEndGame
	Dim newMsgBuf() As Byte
	newMsgBuf = NewMessageMaker("EG", "")
	Log("at end: " & listParticipants.Size)
	If listParticipants.Size = 0 Then
		ShowEndGame("beg")
	End If
	For Each par As gParticipant In listParticipants
		If Not(par.ParticipantId=myID) Then
			roomConfig.sendReliableRealTimeMessage(Room, GGS.GamesClient, par.ParticipantId, newMsgBuf)
		End If
	Next
End Sub

Sub broadcastMyScore
	If bGameStarted Then 'send unreliable
		Dim newMsgBuf() As Byte
		newMsgBuf = NewMessageMaker("S", myScore)
		For Each par As gParticipant In listParticipants
			If Not(par.ParticipantId=myID) Then
				roomConfig.sendUnreliableRealTimeMessage(Room, GGS.GamesClient, par.ParticipantId, newMsgBuf)
			End If
		Next
	Else 'sendReliable
		Dim newMsgBuf() As Byte
		newMsgBuf = NewMessageMaker("S", myScore)
		For Each par As gParticipant In listParticipants
			If Not(par.ParticipantId=myID) Then
				roomConfig.sendReliableRealTimeMessage(Room, GGS.GamesClient, par.ParticipantId, newMsgBuf)
			End If
		Next
	End If
End Sub

Sub updateTime(timeleft As Float)
	If timeleft < lblTime.Text Then
		lblTime.Text = NumberFormat(timeleft, 0, 1)	
	End If
	
	'gameleader stops when realtimemessagesent listener is updated with token
	If timeleft < .1 Then
		If bPlaySolo Then
			bGameStarted = False
			ShowEndGame("ut1")
		Else If Not(bGameLeader) Then
			bGameStarted = False
			ShowEndGame("ut2")
		End If
	End If
	
End Sub

Sub ShowEndGame(caller As String)
	btnLeaveRoom.Visible = True
	btnLeaveRoom.BringToFront
	If bPlaySolo Then
		btnLeaveRoom.Text = "Leave game"
	Else
		btnLeaveRoom.Text = "Leave Room"
	End If
End Sub

Sub updateOpponentScore(participantID As String, score As Int)
	Dim parData As participantData
	parData = mapParticipants.Get(participantID)
	If parData.score < score Then
		parData.score = score
		parData.scoreView.Text = score
	End If
	
	
End Sub

'this means that the list of participants is filled, assign each particpant a
'view to update and store it in the map
Sub setupParticipantMap
	mapParticipants.Initialize
	Dim counter As Int
	counter = 1
	
	lblNameP1.Text = ""
	lblScoreP1.Text = ""
	lblNameP2.Text = ""
	lblScoreP2.Text = ""
	lblNameP3.Text = ""
	lblScoreP3.Text = ""
	
	
	For Each par As gParticipant In listParticipants
		If Not(par.ParticipantId = myID) Then
			Dim tempParData As participantData
			tempParData.Initialize
			Select counter
				Case 1
					tempParData.nameView = lblNameP1
					tempParData.scoreView = lblScoreP1
					tempParData.imgView = imgP1
					par.loadIconImage(tempParData.imgView)
					mapParticipants.Put(par.ParticipantId, tempParData)
					lblNameP1.Text = par.DisplayName
					lblScoreP1.Text = 0
				Case 2
					tempParData.nameView = lblNameP2
					tempParData.scoreView = lblScoreP2
					tempParData.imgView = imgP2
					par.loadIconImage(tempParData.imgView)
					mapParticipants.Put(par.ParticipantId, tempParData)
					lblNameP2.Text = par.DisplayName
					lblScoreP2.Text = 0
				Case 3
					tempParData.nameView = lblNameP3
					tempParData.scoreView = lblScoreP3
					tempParData.imgView = imgP3
					par.loadIconImage(tempParData.imgView)
					mapParticipants.Put(par.ParticipantId, tempParData)
					lblNameP3.Text = par.DisplayName
					lblScoreP3.Text = 0
			End Select
			counter = counter+1
		End If
	Next

End Sub

Sub ResetClient
	GGS.onStop(True)
	GGS.initialize("GGS")
	GGS.onStart(True)
End Sub

Sub btnLeaveRoom_Click
	btnLeaveRoom.Visible = False
	If Room.Status = Room.STATUS_NULL Then
		roomconfig_OnLeftRoom(0, Null)
	Else
		roomConfig.leaveRoom(GGS.GamesClient, Room)
	End If
	
End Sub

Sub roomconfig_OnLeftRoom (statusCode As Int, roomID As String)
	pnlGame.Left = 100%x
	pnlSelect.Left = 0
	ResetClient
End Sub
