﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim GGS As gGoogleGameService
	Dim gClient As gGameClient
	Dim btnAchievements As Button
	Dim btnEasy As Button
	Dim btnHard As Button
	Dim btnLeaderBoards As Button
	
	Dim easyLeaderboard As String = "CgkIno3brc8XEAIQCQ"
	Dim hardLeaderboard As String = "CgkIno3brc8XEAIQCg"
	
	Dim EasyAchievement As String = "CgkIno3brc8XEAIQAg"
	Dim HardAchievement As String = "CgkIno3brc8XEAIQAw"
	Dim IncrementAchievement As String = "CgkIno3brc8XEAIQBA" 'for playing 10 games (either hard or easy)
	Dim HiddenAchievement As String = "CgkIno3brc8XEAIQCw"
	
'	Dim easyLeaderboard As String = "ReplaceMe"
'	Dim hardLeaderboard As String = "ReplaceMe"
'	
'	Dim EasyAchievement As String = "ReplaceMe" 'for playing a game of easy level
'	Dim HardAchievement As String = "ReplaceMe" 'for playing a game of hard level
'	Dim IncrementAchievement As String = "ReplaceMe" 'for playing 10 games (either hard or easy)
'	Dim HiddenAchievement As String = "ReplaceMe" 'not visibile until hard and easy games won
	
	Dim playedHardGameCounter As Int 'it's a hard game, that gets easier as you play it more and more
	
	Dim btnLoadAchivements As Button
	Dim btnEasyLeaderboard As Button
	Dim btnHardLeaderboard As Button
	Dim pnlLeaderboards As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("typeANumber.bal")
	btnLoadAchivements.Visible = False
	pnlLeaderboards.Visible = False
	Activity.Title = "Type A Number"
	GGS.initialize("GGS")
End Sub


Sub Activity_Resume
	pnlLeaderboards.Visible = False
	GGS.onStart(True)
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	GGS.onStop(UserClosed)
End Sub

Sub GGS_OnSignInSucceeded
	Activity.Title = "Type A Number - " & GGS.GamesClient.CurrentPlayer.DisplayName
	GGS.GamesClient.loadAchievements
End Sub

Sub btnAchievements_Click
	GGS.showAchievements
End Sub

Sub btnLeaderBoards_Click
	pnlLeaderboards.Visible = True
	pnlLeaderboards.BringToFront
End Sub

Sub pnlLeaderboards_Touch (Action As Int, X As Float, Y As Float)
	pnlLeaderboards.Visible = False
End Sub

Sub btnHardLeaderboard_Click
	GGS.showLeaderboards(hardLeaderboard)
	pnlLeaderboards.Visible = False
End Sub

Sub btnEasyLeaderboard_Click
	GGS.showLeaderboards(easyLeaderboard)
	pnlLeaderboards.Visible = False
End Sub


Sub btnEasy_Click
	gameIncrement
	GGS.GamesClient.unlockAchievement(EasyAchievement)
	Dim gameResult As Long
	gameResult = Rnd(0, 500)
	Msgbox("You just scored:" & gameResult, GGS.GamesClient.CurrentPlayer.DisplayName & " makes it look so easy")
	GGS.GamesClient.submitScore(easyLeaderboard, gameResult)
End Sub

Sub btnHard_Click
	gameIncrement
	Dim gameResult As Long
	gameResult = Rnd(0, 1000)
	
	gameResult = gameResult + playedHardGameCounter
	Log(gameResult & "GameResult")
	
	If gameResult > 1000 Then
		Msgbox("Superb, you won the hard game!", "Winner")
		GGS.GamesClient.submitScore(hardLeaderboard, gameResult)
		GGS.GamesClient.unlockAchievement(HardAchievement)
		GGS.GamesClient.loadAchievements
	Else
		Msgbox("Not a winner this time.", "Loser")
		playedHardGameCounter = playedHardGameCounter + 1
	End If
End Sub

Sub gameIncrement
	GGS.GamesClient.IncrementAchievement(IncrementAchievement, 1)
End Sub


Sub GGS_onAchievementsLoaded (listAchievements As List)
	If listAchievements = Null Then
		ToastMessageShow("problem getting achievements", False)
	Else
		Dim wonHard As Boolean
		Dim wonEasy As Boolean
		Dim wonBothGames As Boolean
		Dim isManiac As Boolean
		For Each ach As gAchievement In listAchievements
			If ach.AchievementId = IncrementAchievement Then
				playedHardGameCounter = ach.CurrentSteps
				If ach.State = ach.STATE_UNLOCKED Then
					isManiac = True
					playedHardGameCounter = 100 'bonus
				End If
			End If
			If ach.AchievementId = HardAchievement Then
				If ach.State = ach.STATE_UNLOCKED Then
					wonHard = True
				End If
			End If
			If ach.AchievementId = EasyAchievement Then
				If ach.State = ach.STATE_UNLOCKED Then
					wonEasy = True
				End If
			End If
			If ach.AchievementId = HiddenAchievement AND ach.State = ach.STATE_UNLOCKED Then
				wonBothGames = True 
			End If
		Next	
		
		If wonEasy AND wonHard AND Not(wonBothGames) Then
			GGS.GamesClient.unlockAchievement(HiddenAchievement)
			Msgbox("You have mastered both levels of this game!", "Ultimate Achievement Unlocked")
		End If
	End If
	
	
End Sub


